﻿Type=Class
Version=4.2
ModulesStructureVersion=1
B4J=true
@EndOfDesignText@
'Handler class - chart.bas
'Populate the data for the google chart
Sub Class_Globals      
'No globals
End Sub

Public Sub Initialize
'Not used
End Sub

Public Sub Handle(req As ServletRequest, resp As ServletResponse)
	Log("DHT11GoogleLineChart :: Draw Chart")	
	resp.ContentType = "application/json"
	Dim cols As List
	cols.Initialize
	Dim rows As List
	rows.Initialize
	'Create the linechartdata
	CreateLineChartData(cols, rows)
	'Set the options
	Dim options As Map
	options.Initialize
	CreateLineChartOptions(options)
	'Write the response back to the requestor
	Dim jg As JSONGenerator
	jg.Initialize(CreateMap("data": CreateMap ("cols": cols, "rows": rows), "options": options))
	resp.Write(jg.ToString)
End Sub

'
' Parameter id
'
' Parameter Label
' 
' Parameter dataType
' In line, area, bar, column AND candlestick charts (AND combo charts containing only such series), control the Type of the major axis:
' For a discrete axis, set the data column Type To String.
' For a continuous axis, set the data column Type To one of: number, date, DateTime OR timeofday.
' Examples:
' CreateColumn("", "Year", "string")
' CreateColumn("", "Sales", "number")
'
Private Sub CreateColumn(id As String, Label As String, dataType As String) As Map
	Return CreateMap("id": id, "label": Label, "type": dataType)
End Sub

Private Sub CreateRow(Values As List) As Map
	Dim vr As List
	vr.Initialize
	For Each o As Object In Values
		vr.Add(CreateMap("v": "" & o & ""))
		'vr.Add(CreateMap("v": o))
	Next
	Return CreateMap("c": vr)
End Sub

Private Sub CreateLineChartData(cols As List, rows As List)
	'Log("CreateLineChartData :: Start")
	cols.Add(CreateColumn("", "Time", "string"))
	cols.Add(CreateColumn("", "Temp", "number"))
	cols.Add(CreateColumn("", "Hum", "number"))
	'timestamp celcius pressure
	Dim l As List = File.ReadList(File.DirApp, Main.chartdatafile)
	'Log("Data Entries to load = " & l.Size)
	For i = 0 To l.Size - 1
		Dim s() As String = Regex.Split(";", l.Get(i))
		If s.Length = 3 Then
			'Log(s(0) & "," & s(1) & "," & s(2))
			rows.Add(CreateRow(Array As Object(s(0), s(1), s(2))))
		End If
	Next
	'Log("CreateLineChartData :: End")
End Sub

Private Sub CreateLineChartOptions (options As Map)
	options.Put("title", "Temperature & Humidity Data")
	Dim m As Map
	m.Initialize
	m.Put("title", "T=°C, H=%RH")
	Dim c As Map
	c.Initialize
	c.Put("color", "blue")
	m.Put("titleTextStyle", c)
	options.Put("vAxis", m)
End Sub
